﻿using System;
using System.IO;

namespace Web2Pdf
{
    class MainProgram
    {
        private static void ShowHelp()
        {
            Console.WriteLine("Vesko Kolev's Web2PDF converter usage:");
            Console.WriteLine("web2pdf html_url_or_path pdf_file_path title author subject keywords");
        }

        [STAThread]
        public static void Main(string[] args)
        {
            WebPageToPDFGenerator generator = new WebPageToPDFGenerator();
            switch (args.Length)
            {
                case 2:
                    byte[] pdfData = generator.GeneratePdfFromWebPage(args[0]);
                    WriteBinaryDataToFile(pdfData, args[1]);
                    break;
                case 6:
                    pdfData = generator.GeneratePdfFromWebPage(
                        args[0], args[2], args[3], args[4], args[5]);
                    WriteBinaryDataToFile(pdfData, args[1]);
                    break;
                default:
                    ShowHelp();
                    break;
            }
        }

        internal static void WriteBinaryDataToFile(byte[] pdfData, string fileName)
        {
            FileStream fstream = new FileStream(fileName, FileMode.Create);
            using (fstream)
            {
                fstream.Write(pdfData, 0, pdfData.Length);
            }
        }
    }
}
