﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Threading;
using System.Drawing.Drawing2D;

namespace Web2Pdf
{
    internal static class WebPageToImageGenerator
    {
        #region Methods

        public static Bitmap GenerateScreenshot(string htmlUrlOrPath)
        {
            return GenerateScreenshot(htmlUrlOrPath, -1, -1);
        }

        public static Bitmap GenerateScreenshot(string htmlUrlOrPath, int width, int height)
        {
            using (WebBrowser wb = new WebBrowser())
            {
                wb.ScrollBarsEnabled = false;
                wb.ScriptErrorsSuppressed = true;
                wb.Navigate(htmlUrlOrPath);

                while (wb.ReadyState != WebBrowserReadyState.Complete)
                {
                    Application.DoEvents();
                }

                wb.Width = (width != -1) ? width : wb.Document.Body.ScrollRectangle.Width;
                wb.Height = (height != -1) ? height : wb.Height = wb.Document.Body.ScrollRectangle.Height;

                Bitmap screenshot = new Bitmap(wb.Width, wb.Height);
                wb.DrawToBitmap(screenshot, new Rectangle(0, 0, wb.Width, wb.Height));
                wb.Dispose();

                return screenshot;
            }
        }

        #endregion
    }
}
