﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Runtime.InteropServices;

namespace Web2Pdf
{
    [InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface IWebPageToPDFGenerator
    {
        byte[] GeneratePdfFromWebPage(string htmlUrlOrPath);
        string GeneratePdfFromWebPageAsBase64(string htmlUrlOrPath);
        byte[] GeneratePdfFromWebPage(string htmlUrlOrPath, string pdfTitle,
            string pdfAuthor, string pdfSubject, string pdfKeywords);
        string GeneratePdfFromWebPageAsBase64(string htmlUrlOrPath, string pdfTitle,
            string pdfAuthor, string pdfSubject, string pdfKeywords);
    }

    [ComVisible(true)]
    [Guid("38AADE7B-79B8-31A1-B365-22C6AAE5232C")]
    public class WebPageToPDFGenerator : IWebPageToPDFGenerator
    {
        public byte[] GeneratePdfFromWebPage(string htmlUrlOrPath)
        {
            byte[] pdfData = GeneratePdfFromWebPage(htmlUrlOrPath, string.Empty,
                string.Empty, string.Empty, string.Empty);
            return pdfData;
        }

        public string GeneratePdfFromWebPageAsBase64(string htmlUrlOrPath)
        {
            byte[] pdfData = GeneratePdfFromWebPage(htmlUrlOrPath);
            string pdfDataBase64 = Convert.ToBase64String(pdfData);
            return pdfDataBase64;
        }

        public byte[] GeneratePdfFromWebPage(string htmlUrlOrPath, string pdfTitle, 
            string pdfAuthor, string pdfSubject, string pdfKeywords)
        {
            Bitmap screenshot = WebPageToImageGenerator.GenerateScreenshot(htmlUrlOrPath);
            ImageToPDFGenerator imageToPDFGenerator = new ImageToPDFGenerator(
                800, 1050, pdfTitle, pdfAuthor, pdfSubject, pdfKeywords);
            byte[] pdfData = imageToPDFGenerator.Generate(screenshot);
            return pdfData;
        }

        public string GeneratePdfFromWebPageAsBase64(string htmlUrlOrPath, string pdfTitle,
            string pdfAuthor, string pdfSubject, string pdfKeywords)
        {
            byte[] pdfData = GeneratePdfFromWebPage(htmlUrlOrPath, pdfTitle, pdfAuthor, 
                pdfSubject, pdfKeywords);
            string pdfDataBase64 = Convert.ToBase64String(pdfData);
            return pdfDataBase64;
        }
    }
}
