<?php
/*
Plugin Name: Web2Pdf Converter
Plugin URI: http://www.nakov.com/
Description: This plugin allows downloading Web pages and blog posts as PDF files.
Usage: use the_permalink_pdf() function instead the_permalink() to produce a PDF link for the current post.
Author: Svetlin Nakov
Version: 1.0
Author URI: http://www.nakov.com/
*/

function web2pdf($url) {
	$web2pdf = new COM("Web2Pdf.WebPageToPDFGenerator");
	$pdf_base64 = $web2pdf->GeneratePdfFromWebPageAsBase64($url);
  $pdf = base64_decode($pdf_base64);
  return $pdf;
}

function init_action_handler() {
	$pdf_param = $_SERVER['REQUEST_URI'];
	if ($_SERVER["REQUEST_METHOD"]=='GET' && ends_with($pdf_param, '?pdf')) {
		// We should convert the requested page to PDF document
		$protocol = "http";
		if ($_SERVER["HTTPS"] == 'on') {
			$protocol = "https";
		}
		$url = $protocol . '://' . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
		$clean_url = substr($url, 0, strlen($url)-4);

		$pdf = web2pdf($clean_url);
	  header('Content-Type: application/pdf');
	  header('Content-Disposition: attachment; filename=webpage.pdf');
		echo $pdf;
		die();
	}
}

function ends_with($target, $what){
	return strrpos($target, $what) === strlen($target)-strlen($what);
}

function the_permalink_pdf() {
	$permalink = the_permalink();
	echo '?pdf';
}

add_action('init', 'init_action_handler');

?>
